#!/bin/bash
OUT=/tmp/crawler.output
ls 
rm -rf cache.db
echo "Filling the database"
./filldb.sh
echo "Testing the crawler database"
python3 -m pytest test_crawler.py
echo "make a change"
pushd extroot
egrep -liRZ 'A description of another example' . | xargs -0 -l sed -i -e 's/A description of another example/A description of this example/g'
popd
echo "run crawler"
./crawl.py  / > $OUT
# check whether there was something UNAUTHORIZED
set -e
grep "UNAUTHORIZED UPDATE" $OUT
# get the id of the run
RUN_ID=$(grep "./crawl.py -a " $OUT | awk '{ print $3 }')
echo $RUN_ID
echo "run crawler again"
echo "./crawl.py -a $RUN_ID /"
./crawl.py -a $RUN_ID / > $OUT
set +e
if grep "UNAUTHORIZED UPDATE" $OUT
then 
    exit 1
fi
set -e
echo "undo changes"
pushd extroot
egrep -liRZ 'A description of this example' . | xargs -0 -l sed -i -e 's/A description of this example/A description of another example/g'
popd
python3 test_table.py
# TODO the following test deletes lots of the data inserted by the crawler
echo "Testing im and export"
python3 test_im_und_export.py

# Test correct display of data model errors:
echo "Testing recognition of data model problems ... "
python3 -m pytest test_crawl_with_datamodel_problems.py

# Obsolete due to teardown in the above test.
# echo "/n/n/n YOU NEED TO RESTART THE SERVER TO REDO TESTS!!!"
